import gtk
import gtk.glade
import gconf

class Pref:
	def __init__(self):
		# load interfaz
		glade_file = gtk.glade.XML ("prefer.glade",None,None)

		# get widgets
		self.window_prefer = glade_file.get_widget ("window_prefer")
		self.button_close = glade_file.get_widget ("button_close")
		self.button_save = glade_file.get_widget ("button_save")
		self.button_load = glade_file.get_widget ("button_load")
		self.entry_color = glade_file.get_widget ("entry_color")
		self.entry_font = glade_file.get_widget ("entry_font")

		# signals
		self.window_prefer.connect ("delete_event",self.on_delete_event)
		self.button_close.connect ("clicked",self.on_clicked_button_close)
		self.button_save.connect ("clicked",self.on_clicked_button_save)
		self.button_load.connect ("clicked",self.on_clicked_button_load)

		# show all widgets
		self.window_prefer.show_all()
	

	def main(self):
		"main loop"

		gtk.main()


	def load_preferences(self):
		"load preferences"

		try:
			client = gconf.client_get_default()

			color = client.get_string('/apps/diagnomeapp/color')
			font = client.get_string('/apps/diagnomeapp/font')
			self.entry_color.set_text(color)
			self.entry_font.set_text(font)
		except:
			print "ups"
		


	def save_preferences(self):
		"save preferences"

		color = self.entry_color.get_text()
		font = self.entry_font.get_text()

		client = gconf.client_get_default()

		client.set_string('/apps/diagnomeapp/color', color)
		client.set_string('/apps/diagnomeapp/font', font)


	def exit_program (self):
        	"End cicle main and close aplication"

        	print "Bye bye!"
        	gtk.main_quit()


	def on_delete_event (self,widget,event,user_data=None):
        	self.exit_program()


	def on_clicked_button_close (self,button,user_data=None):
		self.exit_program()


	def on_clicked_button_save (self,button,user_data=None):
		self.save_preferences()


	def on_clicked_button_load (self,button,user_data=None):
		self.load_preferences()


if __name__ == "__main__":

        pref = Pref ()
	pref.load_preferences()
        pref.main()
