import gtk
import gtk.glade
import os
import gobject
from xml.dom import minidom

# functions
def exit_program():
	"End cicle main and close aplication"

	print "Bye bye!"
	gtk.main_quit()
	
def on_delete_event (widget, event, user_data=None):
	exit_program()	

def on_button1_clicked (button, user_data=None):
	exit_program()	

def get_text_from_node (nodelist):
	"return concatenate data of TEXT NODE"

	rc = ""
	for node in nodelist:
		if node.nodeType == node.TEXT_NODE:
			rc = rc + node.data
		return rc

# file to open
FILE = "data.xml"

# load interfaz from xml file
glade_file = gtk.glade.XML ("interfaz.glade",None,None)

# get widgets
window = glade_file.get_widget ("window")
button = glade_file.get_widget ("button")
viewport = glade_file.get_widget ("viewport")

# connect signals
window.connect ("delete_event",on_delete_event)
button.connect ("clicked",on_button1_clicked)

# create model
treestore = gtk.TreeStore(gobject.TYPE_STRING,
			gobject.TYPE_STRING,
			gobject.TYPE_STRING)

# for display model
treeview = gtk.TreeView (treestore)

# create columns
col = gtk.TreeViewColumn ("ID")
col.set_resizable (True)
treeview.append_column (col)
cell =  gtk.CellRendererText()
col.pack_start (cell,True)
col.add_attribute (cell,"text",0)

col = gtk.TreeViewColumn ("Nombre")
col.set_resizable (True)
treeview.append_column (col)
cell =  gtk.CellRendererText()
col.pack_start (cell,True)
col.add_attribute (cell,"text",1)

col = gtk.TreeViewColumn ("Model")
col.set_resizable (True)
treeview.append_column (col)
cell =  gtk.CellRendererText()
col.pack_start (cell,True)
col.add_attribute (cell,"text",2)

# add treeview to viewport
viewport.add(treeview)

# open file
try:
	dom = minidom.parse(FILE)
	# get first node
	root = dom.firstChild

	for n in root.childNodes:
		if n.nodeType == 1:  # is ELEMENT?
			if n.nodeName == "device":
				id =  n.getElementsByTagName("id")[0]
				name =  n.getElementsByTagName("name")[0]
				model =  n.getElementsByTagName("model")[0]

				ii = get_text_from_node(id.childNodes)
				nm = get_text_from_node(name.childNodes)
				mo = get_text_from_node(model.childNodes)

				# new iter
				newiter = treestore.append(None)
				treestore.set (newiter,
					0,ii,
					1,nm,
					2,mo)
	dom.unlink()

except (RuntimeError):
	print "Error al abrir archivo"
	exit ()

# show widgets
viewport.show()
treeview.show()
window.show_all()

# main loop
gtk.main()
